Index: /trunk/gli/src/org/greenstone/gatherer/msm/MSMPrompt.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/msm/MSMPrompt.java	(revision 4431)
+++ /trunk/gli/src/org/greenstone/gatherer/msm/MSMPrompt.java	(revision 4432)
@@ -43,4 +43,6 @@
 import javax.swing.event.*;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.gui.ModalDialog;
+import org.greenstone.gatherer.gui.SimpleMenuBar;
 import org.greenstone.gatherer.msm.Declarations;
 import org.greenstone.gatherer.msm.MetadataSet;
@@ -77,13 +79,13 @@
     private Object result = null;
 
-    final static private Dimension MDE_SIZE = new Dimension(500,200);
-    final static private Dimension MDS_SIZE = new Dimension(800,400);
-    final static private Dimension PROGRESS_SIZE = new Dimension(500,80);
+    final static private Dimension MDE_SIZE = new Dimension(500,225);
+    final static private Dimension MDS_SIZE = new Dimension(800,425);
+    final static private Dimension PROGRESS_SIZE = new Dimension(500,105);
     final static private Dimension RENAME_LABEL_SIZE = new Dimension(100,25);
-    final static private Dimension RENAME_SIZE = new Dimension(300,120);
-    final static private Dimension SELECT_ELEMENT_SIZE = new Dimension(500,280);
+    final static private Dimension RENAME_SIZE = new Dimension(300,145);
+    final static private Dimension SELECT_ELEMENT_SIZE = new Dimension(500,305);
     final static private Dimension SELECT_LABEL_SIZE = new Dimension(175, 25);
     final static private Dimension SELECT_SET_SIZE = new Dimension(600,210);
-    final static private Dimension SELECT_SIZE = new Dimension(200,200);
+    final static private Dimension SELECT_SIZE = new Dimension(200,225);
     final static private int SELECT_LINE_COUNT = 8;
 	 
@@ -174,5 +176,5 @@
 	    action = Declarations.SKIP;
 	}
-	on_screen.hide();
+	on_screen.setVisible(false);
     }
     /** Method called when the merging process is complete and the progress bar is no longer needed.
@@ -199,8 +201,9 @@
 	action = Declarations.NO_ACTION;
 	// Construction and configuration
-	JDialog dialog = new JDialog();
+	JDialog dialog = new ModalDialog(Gatherer.g_man);
 	dialog.setModal(true);
 	dialog.setSize(MDE_SIZE);
 	dialog.setTitle(get("Merge_MDE"));
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
 	JPanel content_pane = (JPanel)dialog.getContentPane();
 
@@ -269,7 +272,7 @@
 	dialog.setLocation((screen_size.width - MDE_SIZE.width) / 2, (screen_size.height - MDE_SIZE.height) / 2);
 	on_screen = dialog;
-	off_screen.hide();
-	on_screen.show();
-	off_screen.show();
+	off_screen.setVisible(false);
+	on_screen.setVisible(true);
+	off_screen.setVisible(true);
 	on_screen.dispose();
 
@@ -303,8 +306,9 @@
 	action = Declarations.NO_ACTION;
 	// Construction and configuration
-	JDialog dialog = new JDialog();
+	JDialog dialog = new ModalDialog(Gatherer.g_man);
 	dialog.setModal(true);
 	dialog.setSize(MDS_SIZE);
 	dialog.setTitle(get("Merge_MDS"));
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
 	JPanel content_pane = (JPanel)dialog.getContentPane();
 	if(mde_cur != null) {
@@ -398,7 +402,7 @@
 	dialog.setLocation((screen_size.width - MDS_SIZE.width) / 2, (screen_size.height - MDS_SIZE.height) / 2);
 	on_screen = dialog;
-	off_screen.hide();
-	on_screen.show(); // Blocks until hidden.
-	off_screen.show();
+	off_screen.setVisible(false);
+	on_screen.setVisible(true); // Blocks until hidden.
+	off_screen.setVisible(true);
 	on_screen.dispose();
 	on_screen = null;
@@ -427,8 +431,10 @@
     public void startMerge(int element_count) {
 	action = Declarations.NO_ACTION;
-	JDialog dialog = new JDialog();
+	JDialog dialog = new ModalDialog(Gatherer.g_man);
 	dialog.setModal(false);
 	dialog.setSize(PROGRESS_SIZE);
 	dialog.setTitle(get("Merge_Progress"));
+	//dialog.setJMenuBar(new SimpleMenuBar("0")); ?? do we want help here??
+
 	JPanel content_pane = (JPanel)dialog.getContentPane();
 	progress.setMaximum(element_count);
@@ -444,5 +450,5 @@
 	dialog.setLocation((screen_size.width - PROGRESS_SIZE.width) / 2, (screen_size.height - PROGRESS_SIZE.height) / 2);
 	off_screen = dialog;
-	dialog.show();
+	dialog.setVisible(true);
 	content_pane = null;
 	dialog = null;
@@ -455,9 +461,9 @@
 	action = Declarations.NO_ACTION;
 	// Create
-	JDialog dialog = new JDialog();
+	JDialog dialog = new ModalDialog(Gatherer.g_man);
 	dialog.setModal(true);
 	dialog.setSize(RENAME_SIZE);
 	dialog.setTitle(get("Rename"));
-
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
 	JLabel old_name_label = new JLabel(get("Old_Name"));
 	old_name_label.setPreferredSize(RENAME_LABEL_SIZE);
@@ -509,7 +515,7 @@
 	dialog.setLocation((screen_size.width - RENAME_SIZE.width) / 2, (screen_size.height - RENAME_SIZE.height) / 2);
 	on_screen = dialog;
-	off_screen.hide();
-	on_screen.show();
-	off_screen.show();
+	off_screen.setVisible(false);
+	on_screen.setVisible(true);
+	off_screen.setVisible(true);
 	on_screen.dispose();
 	on_screen = null;		  
@@ -567,9 +573,10 @@
 	action = Declarations.NO_ACTION;
 	// Create
-	JDialog dialog = new JDialog();
+	JDialog dialog = new ModalDialog(Gatherer.g_man);
 	dialog.setModal(true);
 	dialog.setSize(SELECT_SIZE);
 	dialog.setTitle(get("Select"));
-		  
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
+
 	JButton ok = new JButton(get("General.OK"));
 	ok.addActionListener(this);
@@ -604,7 +611,7 @@
 	dialog.setLocation((screen_size.width - SELECT_SIZE.width) / 2, (screen_size.height - SELECT_SIZE.height) / 2);
 	on_screen = dialog;
-	off_screen.hide();
-	on_screen.show();
-	off_screen.show();
+	off_screen.setVisible(false);
+	on_screen.setVisible(true);
+	off_screen.setVisible(true);
 	on_screen.dispose();
 	on_screen = null;	
@@ -645,4 +652,5 @@
 	dialog.setSize(SELECT_ELEMENT_SIZE);
 	dialog.setTitle(get("Select_Element_Title"));
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
 	JPanel content_pane = (JPanel) dialog.getContentPane();
 	JPanel control_pane = new JPanel();
@@ -755,5 +763,5 @@
 	// Display
 	dialog.setLocation((screen_size.width - SELECT_ELEMENT_SIZE.width) / 2, (screen_size.height - SELECT_ELEMENT_SIZE.height) / 2);
-	dialog.show();
+	dialog.setVisible(true);
 	// Deallocate everything because JDK1.4 won't.
 	// Why, oh why did I do this?
@@ -818,4 +826,5 @@
 	dialog.setSize(SELECT_SET_SIZE);
 	dialog.setTitle(get("Select_Set_Title"));
+	dialog.setJMenuBar(new SimpleMenuBar("6.8"));
 	JPanel content_pane = (JPanel) dialog.getContentPane();
 	JPanel control_pane = new JPanel();
@@ -863,5 +872,5 @@
 	// Display
 	dialog.setLocation((screen_size.width - SELECT_SET_SIZE.width) / 2, (screen_size.height - SELECT_SET_SIZE.height) / 2);
-	dialog.show();
+	dialog.setVisible(true);
 	Object value = set.getSelectedItem();
 	if(value instanceof MetadataSet) {
@@ -980,5 +989,9 @@
 
     private class MSMDialog
-	extends JDialog {
+	extends ModalDialog {
+
+	public MSMDialog() {
+	    super(Gatherer.g_man);
+	}
 	public void destroy() {
 	    rootPane = null;