Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4582)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionManager.java	(revision 4583)
@@ -124,12 +124,12 @@
     }
     /** A method to add a new subcollection, by specifying its name, metadata element if applicable and Perl expression to filter pages into or out of this collection.
-	  * @param name A <>>String</>> which is a unique identifier of a subcollection.
-	  * @param include A <i>boolean</i> indicating whether this is an inclusion filter (<i>true</i>) or an exclusion one (<i>false</i>).
-	  * @param element An <>>Element</>> which is either the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name.
-	  * @param exp A <>>String</>> containing a Perl expression which is used as the filter for this subcollection.
-	  * @param flags A <strong>String<strong> listing any special flags to be applied when matching the expression.
-	  * @return A <i>boolean</i> with a value of <i>true</i> if the addition was successful.
-		* @see org.greenstone.gatherer.cdm.Subcollection
-	  */
+     * @param name A <>>String</>> which is a unique identifier of a subcollection.
+     * @param include A <i>boolean</i> indicating whether this is an inclusion filter (<i>true</i>) or an exclusion one (<i>false</i>).
+     * @param element An <>>Element</>> which is either the metadata whose value should be matched against the given expression, or <i>null</i> if you wish to match against the file name.
+     * @param exp A <>>String</>> containing a Perl expression which is used as the filter for this subcollection.
+     * @param flags A <strong>String<strong> listing any special flags to be applied when matching the expression.
+     * @return A <i>boolean</i> with a value of <i>true</i> if the addition was successful.
+     * @see org.greenstone.gatherer.cdm.Subcollection
+     */
     public boolean addSubcollection(String name, boolean include, String element, String exp, String flags) {
 	Subcollection sub = null;
@@ -143,11 +143,11 @@
     }
     /** Refresh all derived components using this manager as a model.
-	*/
+     */
     public void changed() {
 	fireContentsChanged(this, 0, getSize() - 1);
     }
     /** Method to retrieve the controls for this manager.
-	  * @return A <Strong>Control</strong> object which contains the controls used to edit the subcollection data.
-	  */
+     * @return A <Strong>Control</strong> object which contains the controls used to edit the subcollection data.
+     */
     public Control getControls() {
 	if(controls == null) {
@@ -163,7 +163,7 @@
     }
     /** Method to retrieve a certain subcollection by its name.
-	  * @param name A <strong>String</strong> which is used as the key for finding the matching subcollection.
-	  * @return The requested <strong>Subcollection</strong> or <i>null</i> if no such subcollection exists.
-	  */
+     * @param name A <strong>String</strong> which is used as the key for finding the matching subcollection.
+     * @return The requested <strong>Subcollection</strong> or <i>null</i> if no such subcollection exists.
+     */
     public Subcollection getSubcollection(String name) {
 	return (Subcollection) subcollections.get(name);
@@ -185,12 +185,12 @@
 
     /** Method to get all of the subindexes set.
-	  * @return A <strong>SubIndexes</strong> object containing all the defined indexes.
-	  */
+     * @return A <strong>SubIndexes</strong> object containing all the defined indexes.
+     */
     public SubIndexes getSubIndexes() {
 	return subindexes;
     }
     /** Method to get all of the subcollections defined.
-	  * @return A <strong>Vector</strong> of subcollections.
-	  */
+     * @return A <strong>Vector</strong> of subcollections.
+     */
     public Vector getSubcollections() {
 	Vector subcollections = new Vector();
@@ -201,6 +201,6 @@
     }
     /** Mark the current controls, if any, as invalid and deallocate them. Any further use of the controls will requires them being rebuilt.
-	* @see org.greenstone.gatherer.cdm.SubcollectionManager.Control
-	*/
+     * @see org.greenstone.gatherer.cdm.SubcollectionManager.Control
+     */
     public void invalidateControls() {
 	if(controls != null) {
@@ -210,12 +210,12 @@
     }
     /** This method attempts to parse a subcollection related command from the given command string. If such a string is successfully parsed, it is immediately added to the data within this collection.
-	  * @param command The <strong>String</strong> to be parsed.
-	  * @param finished This <i>boolean</i> is usually <i>false</i> when called, unless this parse call is being made -after- the entire collection configuration file has been read in in which case it is <i>true</i>.
-	  * @return A <i>boolean</i> which is <i>true</i> if a command was parsed, <i>false</i> otherwise.
-	  * @see org.greenstone.gatherer.cdm.CommandTokenizer
-	  * @see org.greenstone.gatherer.cdm.DefaultSubIndex
-	  * @see org.greenstone.gatherer.cdm.Subcollection
-	  * @see org.greenstone.gatherer.cdm.SubIndex
-	  */
+     * @param command The <strong>String</strong> to be parsed.
+     * @param finished This <i>boolean</i> is usually <i>false</i> when called, unless this parse call is being made -after- the entire collection configuration file has been read in in which case it is <i>true</i>.
+     * @return A <i>boolean</i> which is <i>true</i> if a command was parsed, <i>false</i> otherwise.
+     * @see org.greenstone.gatherer.cdm.CommandTokenizer
+     * @see org.greenstone.gatherer.cdm.DefaultSubIndex
+     * @see org.greenstone.gatherer.cdm.Subcollection
+     * @see org.greenstone.gatherer.cdm.SubIndex
+     */
     public boolean parse(String command, boolean finished) {
 	String temp = command.toLowerCase();
@@ -683,5 +683,5 @@
 
 	/** Method to unregister any listeners to avoid memory leaks.
-			*/
+	 */
 	public void destroy() {
 	}
@@ -726,9 +726,9 @@
 	private class AddListener
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we wish to retrieve information from the various edit controls, and if we have sufficient data to build a new subcollection do so.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 * @see org.greenstone.gatherer.cdm.Subcollection
-				 * @see org.greenstone.gatherer.msm.ElementWrapper
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we wish to retrieve information from the various edit controls, and if we have sufficient data to build a new subcollection do so.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.Subcollection
+	     * @see org.greenstone.gatherer.msm.ElementWrapper
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		String n = name.getText(); // not allowed spaces!
@@ -778,19 +778,19 @@
 	    extends KeyAdapter
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to record that somethings changed, then validate the controls.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to record that somethings changed, then validate the controls.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		changed = true;
 		validate();
 	    }
-				/** Any inheritor of KeyAdapter can override this method so we can be informed when an key has been type in one of our target controls. In this case we want to record that somethings changed, then validate the controls.
-				 * @param event An <strong>KeyEvent</strong> containing information about the event.
-				 */
+	    /** Any inheritor of KeyAdapter can override this method so we can be informed when an key has been type in one of our target controls. In this case we want to record that somethings changed, then validate the controls.
+	     * @param event An <strong>KeyEvent</strong> containing information about the event.
+	     */
 	    public void keyPressed(KeyEvent event) {
 		changed = true;
 		validate();
 	    }
-				/** Method to validate the current editor values, and enable or disable controls based on said values. */
+	    /** Method to validate the current editor values, and enable or disable controls based on said values. */
 	    private void validate() {
 		if(changed && name.getText().length() > 0 && match.getText().length() > 0) {
@@ -805,7 +805,7 @@
 	private class ClearDefaultListener
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to clear the default subindex.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to clear the default subindex.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		setDefaultSubIndex(null);
@@ -817,9 +817,9 @@
 	private class ListListener
 	    implements ListSelectionListener {
-				/** Any implementation of ListSelectionListener must include this method so we can be informed when the selection changes. In this case we want to execute any changes the users made to the entry, then update the controls with details of the new selection.
-				 * @param event A <strong>ListSelectionEvent</strong> containing information related to this event.
-				 * @see org.greenstone.gatherer.cdm.Subcollection
-				 * @see org.greenstone.gatherer.msm.ElementWrapper
-				 */
+	    /** Any implementation of ListSelectionListener must include this method so we can be informed when the selection changes. In this case we want to execute any changes the users made to the entry, then update the controls with details of the new selection.
+	     * @param event A <strong>ListSelectionEvent</strong> containing information related to this event.
+	     * @see org.greenstone.gatherer.cdm.Subcollection
+	     * @see org.greenstone.gatherer.msm.ElementWrapper
+	     */
 	    public void valueChanged(ListSelectionEvent event) {
 		// If we have a previous collection and the users changed something, but not added, then update subcollection.
@@ -896,8 +896,8 @@
 	private class RemoveListener
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subcolleciton selected, and if so remove both it and any subindexes based on it.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 * @see org.greenstone.gatherer.cdm.Subcollection
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subcolleciton selected, and if so remove both it and any subindexes based on it.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.Subcollection
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		if(!subcollection_list.isSelectionEmpty()) {
@@ -911,8 +911,8 @@
 	private class RemoveSubIndexListener
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so remove it.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 * @see org.greenstone.gatherer.cdm.SubIndex
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so remove it.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.SubIndex
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		if(!subindexes_list.isSelectionEmpty()) {
@@ -924,9 +924,9 @@
 	private class SetDefaultListener
 	    implements ActionListener {
-				/** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so set it as default.
-				 * @param event An <strong>ActionEvent</strong> containing information about the event.
-				 * @see org.greenstone.gatherer.cdm.DefaultSubIndex
-				 * @see org.greenstone.gatherer.cdm.SubIndex
-				 */
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so set it as default.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.DefaultSubIndex
+	     * @see org.greenstone.gatherer.cdm.SubIndex
+	     */
 	    public void actionPerformed(ActionEvent event) {
 		if(!subindexes_list.isSelectionEmpty()) {